Page MenuHomePhabricator

[OpenMP][CPU runtime] Add use of TPAUSE to the runtime
ClosedPublic

Authored by tlwilmar on Dec 14 2021, 1:21 PM.

Details

Summary

Add use of TPAUSE (from WAITPKG) to the runtime for Intel hardware, with an envirable KMP_TPAUSE to turn it on in a particular C-state. Always uses TPAUSE if it is selected and enabled by Intel hardware and presence of WAITPKG, and if not, falls back to old way of checking __kmp_use_yield, etc.

Diff Detail

Event Timeline

tlwilmar created this revision.Dec 14 2021, 1:21 PM
tlwilmar requested review of this revision.Dec 14 2021, 1:21 PM
tlwilmar retitled this revision from [OpenMP][CPU runtime] to [OpenMP][CPU runtime] Add us of TPAUSE to the runtime.Dec 14 2021, 1:21 PM
tlwilmar retitled this revision from [OpenMP][CPU runtime] Add us of TPAUSE to the runtime to [OpenMP][CPU runtime] Add use of TPAUSE to the runtime.
jlpeyton accepted this revision.Jan 4 2022, 7:20 AM

LGTM

This revision is now accepted and ready to land.Jan 4 2022, 7:20 AM
This revision was landed with ongoing or failed builds.Jan 18 2022, 8:14 AM
This revision was automatically updated to reflect the committed changes.